// C++ Vererbung: Geom. Objekte
// Klasse Comp (zusammengesetzte Objekte)
//
// Klaus Kusche, 2011

#ifndef _COMP_HXX
#define _COMP_HXX

#include "color.hxx"
#include "bigobj.hxx"

class Comp : public BigObj {
  public:
    Comp(int x, int y, int size) :
      BigObj(Color(0, 0, 0), x, y, 0, 0),  // Basisklassen-Konstruktor aufrufen
      mObjCnt(0), mMaxObjCnt(size), mObj(new BigObj *[size])
      {}  // noch keine Objekte ==> kein draw notwendig
    Comp(const Comp &orig);
    virtual ~Comp();

    bool add(BigObj *obj);

    virtual void setPos(int x, int y);
    virtual void setSize(int w, int h);
    virtual void move(int x, int y);
    virtual void scale(int percentX, int percentY);
    virtual void rotate();

    virtual void draw();
    virtual void undraw();

    virtual Comp *clone() const {
      return new Comp(*this);
    }

  protected:
    int mObjCnt;
    int mMaxObjCnt;
    BigObj **mObj;
    
  private:
    Comp &operator=(const Comp &val); // wegdefinieren (bleibt undef)!
};

#endif
